#
# @(#) $Id: fbs_env.sh,v 1.5 2001/06/20 18:26:33 ivm Exp $
#
# $Log: fbs_env.sh,v $
# Revision 1.5  2001/06/20 18:26:33  ivm
# Fixed minor bugs
#
# Revision 1.4  2000/09/05 18:48:20  ivm
# Added FCSLIB to fbs_env scripts
#
# Revision 1.3  2000/08/18 21:15:43  ivm
# Implemented dynamic re-configuration
#
# Revision 1.2  2000/06/29 20:21:16  ivm
# Renamed FBS_ROOT to FBSNG_ROOT
#
# Revision 1.1  2000/05/19 16:01:29  ivm
# Added non-UPS scripts
#
#

#
# sh(ksh, bash, etc.) script to be sources in order to set up
# FBS user's environment
#
# FBS Administrator. Edit and uncomment if necessary lines between 
# #++ and #--
#

# 1. If necessary, add Python (1.5 or later) and libraries to 
# PATH and PYTHONPATH
# 
# Example:
#++
# PATH=/usr/local/bin:${PATH}; export PATH
# PYTHONPATH=/usr/local/lib/python:${PYTHONPATH}; export PYTHONPATH
#--

# 2. Define locations of FBSNG and FCSLIB
#
# FBSNG_DIR=...(where you unpacked FBS tar file into)...
# FBSNG_ROOT=...(where you created log, cfg subdirectories)...
# FCSLIB_LIB=...(where FCSLIB *.py files are)...
#++
# FBSNG_DIR=...
# FBSNG_ROOT=...
# FCSLIB_LIB=...
# export FBSNG_DIR FBSNG_ROOT FCSLIB_LIB
#--

PATH=${FBSNG_DIR}/bin:${PATH}; export PATH
PYTHONPATH=${FBSNG_DIR}/lib:${FBSNG_DIR}/bin:${FCSLIB_LIB}:${PYTHONPATH}; export PYTHONPATH
FBS_CONFIG=${FBSNG_ROOT}/cfg/fbs.cfg; export FBS_CONFIG
FBS_FARM_CONFIG=${FBSNG_ROOT}/cfg/farm.cfg; export FBS_FARM_CONFIG



