#!/bin/sh -f
#
# @(#) $Id: tailor.sh,v 1.6 2000/09/15 18:28:13 ivm Exp $
#
# $Log: tailor.sh,v $
# Revision 1.6  2000/09/15 18:28:13  ivm
# Produce .pyc and .pyo files for API modules in Makefile, not in
# tailor.sh
#
# Revision 1.5  2000/06/14 20:49:11  ivm
# Make fbsng and fbs synonyms with a symbolic link
#
# Revision 1.4  2000/06/01 14:05:03  ivm
# Fixed UPS_PROD_DIR undefined bug
#
# Revision 1.3  2000/05/22 16:40:04  ivm
# Added templates subdirectory, fixed tailor.sh
#
# Revision 1.2  2000/05/19 14:21:36  ivm
# Added compile_all.py
#
# Revision 1.1  2000/04/21 16:57:48  ivm
# Added Makefiles
# Added UPS stuff
#
#
#

root=${UPS_OPTIONS}

if [ "_$root" = "_" ] ; then
	echo "Usage: ups tailor [-dct] -O <FBSNG root path> <product>"
	exit 1
fi

sed -e s+_ROOT_+${root}+g < ${UPS_PROD_DIR}/ups/setup_env.sh.template \
		> ${UPS_PROD_DIR}/bin/setup_env.sh

sed -e s+_ROOT_+${root}+g < ${UPS_PROD_DIR}/ups/setup_env.csh.template \
		> ${UPS_PROD_DIR}/bin/setup_env.csh

chmod ugo+rx ${UPS_PROD_DIR}/bin/setup_env.csh
chmod ugo+rx ${UPS_PROD_DIR}/bin/setup_env.sh

#
# generate .pyc files for API and other modules
#
. ${SETUPS_DIR}/setups.sh
setup python
setup fcslib
PYTHONPATH=${UPS_PROD_DIR}/bin:${UPS_PROD_DIR}/lib:${PYTHONPATH}
export PYTHONPATH

# python ${UPS_PROD_DIR}/bin/compile_all.py

#
# make "fbsng" synonym to "fbs"
#

ln -sf ${UPS_PROD_DIR}/bin/fbs ${UPS_PROD_DIR}/bin/fbsng
chmod ugo+rx ${UPS_PROD_DIR}/bin/fbsng
